var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// ../../scripts/emotion-shim.js
import { jsx } from "@emotion/react";

// src/evaluate.ts
var kappa = ({
  agreeHighlight,
  agreeNoHighlight,
  disagreeHighlight,
  disagreeNoHighlight
}) => {
  let N = agreeHighlight + disagreeHighlight + agreeNoHighlight + disagreeNoHighlight;
  let p0 = (agreeHighlight + agreeNoHighlight) / N;
  let pe = (agreeHighlight + disagreeHighlight) / N * (agreeHighlight + disagreeNoHighlight) / N + (disagreeNoHighlight + agreeNoHighlight) / N * (disagreeHighlight + agreeNoHighlight) / N;
  let kappa2 = (p0 - pe) / (1 - pe);
  return kappa2 || 0;
};
var evaluate = (_0) => __async(void 0, [_0], function* ({ task, answer }) {
  const evaluation = task.evaluation;
  let state = "unknown";
  const agreement = {
    maroon: 0,
    blue: 0,
    orange: 0,
    yellow: 0,
    lavender: 0
  };
  let highlightsFeedback = new Array(task.view.text.length).fill(null);
  if (evaluation.mode === "auto") {
    const highlightsA = (answer == null ? void 0 : answer.highlights) || [];
    const highlightsS = evaluation.highlights;
    Object.keys(agreement).forEach((c) => {
      const matrix = {
        agreeNoHighlight: 0,
        agreeHighlight: 0,
        disagreeNoHighlight: 0,
        disagreeHighlight: 0
      };
      for (let i = 0; i < task.view.text.length; i++) {
        const hA = highlightsA[i];
        const hS = highlightsS[i];
        if (hA === c && hS === c) {
          matrix.agreeHighlight += 1;
        } else if (hS === c && hA !== c) {
          matrix.disagreeHighlight += 1;
        } else if (hS !== c && hA === c) {
          matrix.disagreeNoHighlight += 1;
        } else if (hS !== c && hA !== c) {
          matrix.agreeNoHighlight += 1;
        }
        if (task.evaluation.showFeedback && task.feedback.highlightAgreement) {
          if (hA !== null && hA === hS) {
            highlightsFeedback[i] = "correct";
          } else if (hA !== null && hA !== hS) {
            highlightsFeedback[i] = "wrong";
          }
        }
      }
      agreement[c] = kappa(matrix);
    });
    state = "correct";
    Object.entries(task.view.colors).forEach(([k, v]) => {
      if (v.enabled && agreement[k] < task.evaluation.cutoffs[k]) {
        state = "wrong";
      }
    });
  } else if (evaluation.mode === "manual") {
    state = "manual";
  }
  return {
    state,
    subtype: "highlighting",
    allowRetry: task.evaluation.enableRetry,
    agreement,
    highlightsFeedback
  };
});

// src/EvaluationForm.tsx
import {
  StyledInput,
  Box as Box2,
  HookFormController,
  FormHelperText,
  FormLabel
} from "@openpatch/patches";
import { useTranslations as useTranslations2 } from "@vocab/react";
import { Fragment, useEffect as useEffect2, useReducer } from "react";
import { useFormContext } from "react-hook-form";

// src/HighlightText.tsx
import { css } from "@emotion/react";
import { Box, ButtonGroup, ButtonOutline } from "@openpatch/patches";
import { useTranslations } from "@vocab/react";
import { useEffect, useRef } from "react";

// src/colors.ts
var colors = {
  blue: { bg: "#4363d8", fg: "#FFFFFF" },
  lavender: { bg: "#dcbeff", fg: "#000000" },
  maroon: {
    bg: "#800000",
    fg: "#FFFFFF"
  },
  orange: {
    bg: "#f58231",
    fg: "#FFFFFF"
  },
  yellow: { bg: "#ffe119", fg: "#000000" }
};
function shadeColor(col, amt) {
  var usePound = false;
  if (col[0] == "#") {
    col = col.slice(1);
    usePound = true;
  }
  var num = parseInt(col, 16);
  var r = (num >> 16) + amt;
  if (r > 255)
    r = 255;
  else if (r < 0)
    r = 0;
  var b = (num >> 8 & 255) + amt;
  if (b > 255)
    b = 255;
  else if (b < 0)
    b = 0;
  var g = (num & 255) + amt;
  if (g > 255)
    g = 255;
  else if (g < 0)
    g = 0;
  return (usePound ? "#" : "") + (g | b << 8 | r << 16).toString(16);
}

// src/locales.vocab/index.ts
import { createLanguage, createTranslationFile } from "@vocab/core/runtime";
var translations = createTranslationFile({
  "en-GB": createLanguage({
    description: "A task bit for highlighting parts of a given text.",
    name: "Highlighting",
    instruction: "Instruction",
    text: "Text to Highlight",
    "example.instruction": "Mark all fruits with '{{maroon}}' and all vegetables with '{{lavender}}'",
    "example.text": "Cale, Srawberry, Banana, Milk, Test",
    "severity.error": "Error",
    "severity.info": "Info",
    "severity.success": "Success",
    "severity.warning": "Warning",
    "highlight-title": "Highlight the selected text by clicking this button or by pressing {id, number}",
    maroon: "Maroon",
    yellow: "Yellow",
    orange: "Orange",
    blue: "Blue",
    lavender: "Lavender",
    "maroon-button": "Maroon ({id, number})",
    "yellow-button": "Yellow ({id, number})",
    "orange-button": "Orange ({id, number})",
    "blue-button": "Blue ({id, number})",
    "instruction-shortcodes": "You can use '{{color-name}}' in your instruction to display a smaller version of the button for this color. Options for color-name are: blue, lavender, maroon, orange and yellow.",
    "instruction-enabled-highlight-colors": "Here you can enabled multiple colors for the highlighting task. You can also give each color a custom name. The custom name does not influence the placeholder for the instruction.",
    "lavender-button": "Lavender ({id, number})",
    "enabled-highlight-colors": "Enabled Highlight Colors",
    erase: "Erase",
    reset: "Reset",
    "erase-title": "Erase the highlight of the selected text by clicking this button or by pressing Delete",
    "reset-title": "Reset all highlights",
    solution: "Solution",
    "instruction-solution": "You can define a solution which will be used for evaluating the answers.",
    cutoffs: "Cutoffs",
    "instruction-cutoffs": "For comparing your solution with an answer an agreement value will be calculated (Cohen's Kappa). You can define cutoff threshold for each highlight color. If the agreement value is above the cutoff score, the answer will be evaluated as correct. An agreement value of 1 means the answer and the solution are the same. An agreement value of 0 means nothing was highlighted. An agreement value of -1 means everything but the solution was highlighted. An answer will be regared as correct if all cutoffs are reached.",
    "highlight-agreement": "Highlight Agreement",
    "highlight-agreement-description": "If checked all correct highlighted areas will be marked in green and all wrong highlighted areas will be marked red."
  }),
  en: createLanguage({
    description: "A task bit for highlighting parts of a given text.",
    name: "Highlighting",
    instruction: "Instruction",
    text: "Text to Highlight",
    "example.instruction": "Mark all fruits with '{{maroon}}' and all vegetables with '{{lavender}}'",
    "example.text": "Cale, Srawberry, Banana, Milk, Test",
    "severity.error": "Error",
    "severity.info": "Info",
    "severity.success": "Success",
    "severity.warning": "Warning",
    "highlight-title": "Highlight the selected text by clicking this button or by pressing {id, number}",
    maroon: "Maroon",
    yellow: "Yellow",
    orange: "Orange",
    blue: "Blue",
    lavender: "Lavender",
    "maroon-button": "Maroon ({id, number})",
    "yellow-button": "Yellow ({id, number})",
    "orange-button": "Orange ({id, number})",
    "blue-button": "Blue ({id, number})",
    "instruction-shortcodes": "You can use '{{color-name}}' in your instruction to display a smaller version of the button for this color. Options for color-name are: blue, lavender, maroon, orange and yellow.",
    "instruction-enabled-highlight-colors": "Here you can enabled multiple colors for the highlighting task. You can also give each color a custom name. The custom name does not influence the placeholder for the instruction.",
    "lavender-button": "Lavender ({id, number})",
    "enabled-highlight-colors": "Enabled Highlight Colors",
    erase: "Erase",
    reset: "Reset",
    "erase-title": "Erase the highlight of the selected text by clicking this button or by pressing Delete",
    "reset-title": "Reset all highlights",
    solution: "Solution",
    "instruction-solution": "You can define a solution which will be used for evaluating the answers.",
    cutoffs: "Cutoffs",
    "instruction-cutoffs": "For comparing your solution with an answer an agreement value will be calculated (Cohen's Kappa). You can define cutoff threshold for each highlight color. If the agreement value is above the cutoff score, the answer will be evaluated as correct. An agreement value of 1 means the answer and the solution are the same. An agreement value of 0 means nothing was highlighted. An agreement value of -1 means everything but the solution was highlighted. An answer will be regared as correct if all cutoffs are reached.",
    "highlight-agreement": "Highlight Agreement",
    "highlight-agreement-description": "If checked all correct highlighted areas will be marked in green and all wrong highlighted areas will be marked red."
  }),
  "en-US": createLanguage({
    description: "A task bit for highlighting parts of a given text.",
    name: "Highlighting",
    instruction: "Instruction",
    text: "Text to Highlight",
    "example.instruction": "Mark all fruits with '{{maroon}}' and all vegetables with '{{lavender}}'",
    "example.text": "Cale, Srawberry, Banana, Milk, Test",
    "severity.error": "Error",
    "severity.info": "Info",
    "severity.success": "Success",
    "severity.warning": "Warning",
    "highlight-title": "Highlight the selected text by clicking this button or by pressing {id, number}",
    maroon: "Maroon",
    yellow: "Yellow",
    orange: "Orange",
    blue: "Blue",
    lavender: "Lavender",
    "maroon-button": "Maroon ({id, number})",
    "yellow-button": "Yellow ({id, number})",
    "orange-button": "Orange ({id, number})",
    "blue-button": "Blue ({id, number})",
    "instruction-shortcodes": "You can use '{{color-name}}' in your instruction to display a smaller version of the button for this color. Options for color-name are: blue, lavender, maroon, orange and yellow.",
    "instruction-enabled-highlight-colors": "Here you can enabled multiple colors for the highlighting task. You can also give each color a custom name. The custom name does not influence the placeholder for the instruction.",
    "lavender-button": "Lavender ({id, number})",
    "enabled-highlight-colors": "Enabled Highlight Colors",
    erase: "Erase",
    reset: "Reset",
    "erase-title": "Erase the highlight of the selected text by clicking this button or by pressing Delete",
    "reset-title": "Reset all highlights",
    solution: "Solution",
    "instruction-solution": "You can define a solution which will be used for evaluating the answers.",
    cutoffs: "Cutoffs",
    "instruction-cutoffs": "For comparing your solution with an answer an agreement value will be calculated (Cohen's Kappa). You can define cutoff threshold for each highlight color. If the agreement value is above the cutoff score, the answer will be evaluated as correct. An agreement value of 1 means the answer and the solution are the same. An agreement value of 0 means nothing was highlighted. An agreement value of -1 means everything but the solution was highlighted. An answer will be regared as correct if all cutoffs are reached.",
    "highlight-agreement": "Highlight Agreement",
    "highlight-agreement-description": "If checked all correct highlighted areas will be marked in green and all wrong highlighted areas will be marked red."
  }),
  de: createLanguage({
    description: "A task bit for highlighting parts of a given text.",
    name: "Highlighting",
    instruction: "Instruction",
    text: "Text to Highlight",
    "example.instruction": "Mark all fruits with '{{maroon}}' and all vegetables with '{{lavender}}'",
    "example.text": "Cale, Srawberry, Banana, Milk, Test",
    "severity.error": "Error",
    "severity.info": "Info",
    "severity.success": "Success",
    "severity.warning": "Warning",
    "highlight-title": "Highlight the selected text by clicking this button or by pressing {id, number}",
    maroon: "Maroon",
    yellow: "Yellow",
    orange: "Orange",
    blue: "Blue",
    lavender: "Lavender",
    "maroon-button": "Maroon ({id, number})",
    "yellow-button": "Yellow ({id, number})",
    "orange-button": "Orange ({id, number})",
    "blue-button": "Blue ({id, number})",
    "instruction-shortcodes": "You can use '{{color-name}}' in your instruction to display a smaller version of the button for this color. Options for color-name are: blue, lavender, maroon, orange and yellow.",
    "instruction-enabled-highlight-colors": "Here you can enabled multiple colors for the highlighting task. You can also give each color a custom name. The custom name does not influence the placeholder for the instruction.",
    "lavender-button": "Lavender ({id, number})",
    "enabled-highlight-colors": "Enabled Highlight Colors",
    erase: "Erase",
    reset: "Reset",
    "erase-title": "Erase the highlight of the selected text by clicking this button or by pressing Delete",
    "reset-title": "Reset all highlights",
    solution: "Solution",
    "instruction-solution": "You can define a solution which will be used for evaluating the answers.",
    cutoffs: "Cutoffs",
    "instruction-cutoffs": "For comparing your solution with an answer an agreement value will be calculated (Cohen's Kappa). You can define cutoff threshold for each highlight color. If the agreement value is above the cutoff score, the answer will be evaluated as correct. An agreement value of 1 means the answer and the solution are the same. An agreement value of 0 means nothing was highlighted. An agreement value of -1 means everything but the solution was highlighted. An answer will be regared as correct if all cutoffs are reached.",
    "highlight-agreement": "Highlight Agreement",
    "highlight-agreement-description": "If checked all correct highlighted areas will be marked in green and all wrong highlighted areas will be marked red."
  }),
  fr: createLanguage({
    description: "A task bit for highlighting parts of a given text.",
    name: "Highlighting",
    instruction: "Instruction",
    text: "Text to Highlight",
    "example.instruction": "Mark all fruits with '{{maroon}}' and all vegetables with '{{lavender}}'",
    "example.text": "Cale, Srawberry, Banana, Milk, Test",
    "severity.error": "Error",
    "severity.info": "Info",
    "severity.success": "Success",
    "severity.warning": "Warning",
    "highlight-title": "Highlight the selected text by clicking this button or by pressing {id, number}",
    maroon: "Maroon",
    yellow: "Yellow",
    orange: "Orange",
    blue: "Blue",
    lavender: "Lavender",
    "maroon-button": "Maroon ({id, number})",
    "yellow-button": "Yellow ({id, number})",
    "orange-button": "Orange ({id, number})",
    "blue-button": "Blue ({id, number})",
    "instruction-shortcodes": "You can use '{{color-name}}' in your instruction to display a smaller version of the button for this color. Options for color-name are: blue, lavender, maroon, orange and yellow.",
    "instruction-enabled-highlight-colors": "Here you can enabled multiple colors for the highlighting task. You can also give each color a custom name. The custom name does not influence the placeholder for the instruction.",
    "lavender-button": "Lavender ({id, number})",
    "enabled-highlight-colors": "Enabled Highlight Colors",
    erase: "Erase",
    reset: "Reset",
    "erase-title": "Erase the highlight of the selected text by clicking this button or by pressing Delete",
    "reset-title": "Reset all highlights",
    solution: "Solution",
    "instruction-solution": "You can define a solution which will be used for evaluating the answers.",
    cutoffs: "Cutoffs",
    "instruction-cutoffs": "For comparing your solution with an answer an agreement value will be calculated (Cohen's Kappa). You can define cutoff threshold for each highlight color. If the agreement value is above the cutoff score, the answer will be evaluated as correct. An agreement value of 1 means the answer and the solution are the same. An agreement value of 0 means nothing was highlighted. An agreement value of -1 means everything but the solution was highlighted. An answer will be regared as correct if all cutoffs are reached.",
    "highlight-agreement": "Highlight Agreement",
    "highlight-agreement-description": "If checked all correct highlighted areas will be marked in green and all wrong highlighted areas will be marked red."
  }),
  es: createLanguage({
    description: "A task bit for highlighting parts of a given text.",
    name: "Highlighting",
    instruction: "Instruction",
    text: "Text to Highlight",
    "example.instruction": "Mark all fruits with '{{maroon}}' and all vegetables with '{{lavender}}'",
    "example.text": "Cale, Srawberry, Banana, Milk, Test",
    "severity.error": "Error",
    "severity.info": "Info",
    "severity.success": "Success",
    "severity.warning": "Warning",
    "highlight-title": "Highlight the selected text by clicking this button or by pressing {id, number}",
    maroon: "Maroon",
    yellow: "Yellow",
    orange: "Orange",
    blue: "Blue",
    lavender: "Lavender",
    "maroon-button": "Maroon ({id, number})",
    "yellow-button": "Yellow ({id, number})",
    "orange-button": "Orange ({id, number})",
    "blue-button": "Blue ({id, number})",
    "instruction-shortcodes": "You can use '{{color-name}}' in your instruction to display a smaller version of the button for this color. Options for color-name are: blue, lavender, maroon, orange and yellow.",
    "instruction-enabled-highlight-colors": "Here you can enabled multiple colors for the highlighting task. You can also give each color a custom name. The custom name does not influence the placeholder for the instruction.",
    "lavender-button": "Lavender ({id, number})",
    "enabled-highlight-colors": "Enabled Highlight Colors",
    erase: "Erase",
    reset: "Reset",
    "erase-title": "Erase the highlight of the selected text by clicking this button or by pressing Delete",
    "reset-title": "Reset all highlights",
    solution: "Solution",
    "instruction-solution": "You can define a solution which will be used for evaluating the answers.",
    cutoffs: "Cutoffs",
    "instruction-cutoffs": "For comparing your solution with an answer an agreement value will be calculated (Cohen's Kappa). You can define cutoff threshold for each highlight color. If the agreement value is above the cutoff score, the answer will be evaluated as correct. An agreement value of 1 means the answer and the solution are the same. An agreement value of 0 means nothing was highlighted. An agreement value of -1 means everything but the solution was highlighted. An answer will be regared as correct if all cutoffs are reached.",
    "highlight-agreement": "Highlight Agreement",
    "highlight-agreement-description": "If checked all correct highlighted areas will be marked in green and all wrong highlighted areas will be marked red."
  }),
  nl: createLanguage({
    description: "A task bit for highlighting parts of a given text.",
    name: "Highlighting",
    instruction: "Instruction",
    text: "Text to Highlight",
    "example.instruction": "Mark all fruits with '{{maroon}}' and all vegetables with '{{lavender}}'",
    "example.text": "Cale, Srawberry, Banana, Milk, Test",
    "severity.error": "Error",
    "severity.info": "Info",
    "severity.success": "Success",
    "severity.warning": "Warning",
    "highlight-title": "Highlight the selected text by clicking this button or by pressing {id, number}",
    maroon: "Maroon",
    yellow: "Yellow",
    orange: "Orange",
    blue: "Blue",
    lavender: "Lavender",
    "maroon-button": "Maroon ({id, number})",
    "yellow-button": "Yellow ({id, number})",
    "orange-button": "Orange ({id, number})",
    "blue-button": "Blue ({id, number})",
    "instruction-shortcodes": "You can use '{{color-name}}' in your instruction to display a smaller version of the button for this color. Options for color-name are: blue, lavender, maroon, orange and yellow.",
    "instruction-enabled-highlight-colors": "Here you can enabled multiple colors for the highlighting task. You can also give each color a custom name. The custom name does not influence the placeholder for the instruction.",
    "lavender-button": "Lavender ({id, number})",
    "enabled-highlight-colors": "Enabled Highlight Colors",
    erase: "Erase",
    reset: "Reset",
    "erase-title": "Erase the highlight of the selected text by clicking this button or by pressing Delete",
    "reset-title": "Reset all highlights",
    solution: "Solution",
    "instruction-solution": "You can define a solution which will be used for evaluating the answers.",
    cutoffs: "Cutoffs",
    "instruction-cutoffs": "For comparing your solution with an answer an agreement value will be calculated (Cohen's Kappa). You can define cutoff threshold for each highlight color. If the agreement value is above the cutoff score, the answer will be evaluated as correct. An agreement value of 1 means the answer and the solution are the same. An agreement value of 0 means nothing was highlighted. An agreement value of -1 means everything but the solution was highlighted. An answer will be regared as correct if all cutoffs are reached.",
    "highlight-agreement": "Highlight Agreement",
    "highlight-agreement-description": "If checked all correct highlighted areas will be marked in green and all wrong highlighted areas will be marked red."
  }),
  pt: createLanguage({
    description: "A task bit for highlighting parts of a given text.",
    name: "Highlighting",
    instruction: "Instruction",
    text: "Text to Highlight",
    "example.instruction": "Mark all fruits with '{{maroon}}' and all vegetables with '{{lavender}}'",
    "example.text": "Cale, Srawberry, Banana, Milk, Test",
    "severity.error": "Error",
    "severity.info": "Info",
    "severity.success": "Success",
    "severity.warning": "Warning",
    "highlight-title": "Highlight the selected text by clicking this button or by pressing {id, number}",
    maroon: "Maroon",
    yellow: "Yellow",
    orange: "Orange",
    blue: "Blue",
    lavender: "Lavender",
    "maroon-button": "Maroon ({id, number})",
    "yellow-button": "Yellow ({id, number})",
    "orange-button": "Orange ({id, number})",
    "blue-button": "Blue ({id, number})",
    "instruction-shortcodes": "You can use '{{color-name}}' in your instruction to display a smaller version of the button for this color. Options for color-name are: blue, lavender, maroon, orange and yellow.",
    "instruction-enabled-highlight-colors": "Here you can enabled multiple colors for the highlighting task. You can also give each color a custom name. The custom name does not influence the placeholder for the instruction.",
    "lavender-button": "Lavender ({id, number})",
    "enabled-highlight-colors": "Enabled Highlight Colors",
    erase: "Erase",
    reset: "Reset",
    "erase-title": "Erase the highlight of the selected text by clicking this button or by pressing Delete",
    "reset-title": "Reset all highlights",
    solution: "Solution",
    "instruction-solution": "You can define a solution which will be used for evaluating the answers.",
    cutoffs: "Cutoffs",
    "instruction-cutoffs": "For comparing your solution with an answer an agreement value will be calculated (Cohen's Kappa). You can define cutoff threshold for each highlight color. If the agreement value is above the cutoff score, the answer will be evaluated as correct. An agreement value of 1 means the answer and the solution are the same. An agreement value of 0 means nothing was highlighted. An agreement value of -1 means everything but the solution was highlighted. An answer will be regared as correct if all cutoffs are reached.",
    "highlight-agreement": "Highlight Agreement",
    "highlight-agreement-description": "If checked all correct highlighted areas will be marked in green and all wrong highlighted areas will be marked red."
  }),
  tr: createLanguage({
    description: "A task bit for highlighting parts of a given text.",
    name: "Highlighting",
    instruction: "Instruction",
    text: "Text to Highlight",
    "example.instruction": "Mark all fruits with '{{maroon}}' and all vegetables with '{{lavender}}'",
    "example.text": "Cale, Srawberry, Banana, Milk, Test",
    "severity.error": "Error",
    "severity.info": "Info",
    "severity.success": "Success",
    "severity.warning": "Warning",
    "highlight-title": "Highlight the selected text by clicking this button or by pressing {id, number}",
    maroon: "Maroon",
    yellow: "Yellow",
    orange: "Orange",
    blue: "Blue",
    lavender: "Lavender",
    "maroon-button": "Maroon ({id, number})",
    "yellow-button": "Yellow ({id, number})",
    "orange-button": "Orange ({id, number})",
    "blue-button": "Blue ({id, number})",
    "instruction-shortcodes": "You can use '{{color-name}}' in your instruction to display a smaller version of the button for this color. Options for color-name are: blue, lavender, maroon, orange and yellow.",
    "instruction-enabled-highlight-colors": "Here you can enabled multiple colors for the highlighting task. You can also give each color a custom name. The custom name does not influence the placeholder for the instruction.",
    "lavender-button": "Lavender ({id, number})",
    "enabled-highlight-colors": "Enabled Highlight Colors",
    erase: "Erase",
    reset: "Reset",
    "erase-title": "Erase the highlight of the selected text by clicking this button or by pressing Delete",
    "reset-title": "Reset all highlights",
    solution: "Solution",
    "instruction-solution": "You can define a solution which will be used for evaluating the answers.",
    cutoffs: "Cutoffs",
    "instruction-cutoffs": "For comparing your solution with an answer an agreement value will be calculated (Cohen's Kappa). You can define cutoff threshold for each highlight color. If the agreement value is above the cutoff score, the answer will be evaluated as correct. An agreement value of 1 means the answer and the solution are the same. An agreement value of 0 means nothing was highlighted. An agreement value of -1 means everything but the solution was highlighted. An answer will be regared as correct if all cutoffs are reached.",
    "highlight-agreement": "Highlight Agreement",
    "highlight-agreement-description": "If checked all correct highlighted areas will be marked in green and all wrong highlighted areas will be marked red."
  })
});
var locales_default = translations;

// src/HighlightText.tsx
var HighlightText = ({
  text = "",
  highlights = [],
  feedback,
  colors: colors2,
  onHighlight,
  selection,
  onSelect,
  onErase,
  onReset
}) => {
  const ref = useRef(null);
  const { t } = useTranslations(locales_default);
  const colorKeys = Object.keys(colors2).filter((c) => colors2[c].enabled).sort((a, b) => a > b ? 1 : -1);
  const handleSelect = () => {
    const s = window.getSelection();
    if ((s == null ? void 0 : s.type) === "Range" && ref.current) {
      const r = s.getRangeAt(0);
      const preSelectionRange = r.cloneRange();
      preSelectionRange.selectNodeContents(ref.current);
      preSelectionRange.setEnd(r.startContainer, r.startOffset);
      const from = preSelectionRange.toString().length;
      const to = from + r.toString().length;
      onSelect(from, to);
    }
  };
  useEffect(() => {
    window.addEventListener("keyup", handleKeyup);
    return () => {
      window.removeEventListener("keyup", handleKeyup);
    };
  }, []);
  const handleKeyup = ({ code }) => {
    switch (code) {
      case "Digit1":
        if (colorKeys.length > 0) {
          onHighlight(colorKeys[0])();
        }
        break;
      case "Digit2":
        if (colorKeys.length > 1) {
          onHighlight(colorKeys[1])();
        }
        break;
      case "Digit3":
        if (colorKeys.length > 2) {
          onHighlight(colorKeys[2])();
        }
        break;
      case "Digit4":
        if (colorKeys.length > 3) {
          onHighlight(colorKeys[3])();
        }
        break;
      case "Digit5":
        if (colorKeys.length > 4) {
          onHighlight(colorKeys[4])();
        }
        break;
      case "Delete":
        onErase();
        break;
    }
  };
  const cells = text.split("").map((t2, i) => {
    const highlight = highlights[i];
    let bg = void 0;
    let fg = void 0;
    if (highlight) {
      bg = colors[highlight].bg;
      fg = colors[highlight].fg;
    }
    const style = {
      backgroundColor: bg,
      color: fg,
      borderBottomWidth: 0,
      borderBottomStyle: "solid"
    };
    if ((feedback == null ? void 0 : feedback[i]) === "correct") {
      style.borderBottomWidth = 8;
      style.borderBottomColor = "green";
    } else if ((feedback == null ? void 0 : feedback[i]) === "wrong") {
      style.borderBottomWidth = 8;
      style.borderBottomColor = "red";
    }
    return /* @__PURE__ */ jsx("span", {
      "data-id": i,
      style,
      key: i
    }, t2);
  });
  useEffect(() => {
    var _a, _b;
    if (selection && ref.current) {
      let charIndex = 0;
      const r = new Range();
      r.setStart(ref.current, 0);
      r.collapse(true);
      const nodeStack = [ref.current];
      let node;
      let foundStart = false;
      let stop = false;
      while (!stop && (node = nodeStack.pop())) {
        if (!node) {
          break;
        }
        if (node.nodeType === 3) {
          const nextCharIndex = charIndex + (node.nodeValue || "").length;
          if (!foundStart && selection.from >= charIndex && selection.from <= nextCharIndex) {
            r.setStart(node, selection.from - charIndex);
            foundStart = true;
          }
          if (foundStart && selection.to >= charIndex && selection.to <= nextCharIndex) {
            r.setEnd(node, selection.to - charIndex);
            stop = true;
          }
          charIndex = nextCharIndex;
        } else {
          let i = node.childNodes.length;
          while (i--) {
            nodeStack.push(node.childNodes[i]);
          }
        }
      }
      (_a = window.getSelection()) == null ? void 0 : _a.removeAllRanges();
      (_b = window.getSelection()) == null ? void 0 : _b.addRange(r);
    }
  }, [selection]);
  return /* @__PURE__ */ jsx(Box, null, /* @__PURE__ */ jsx(Box, {
    display: "flex",
    mb: "standard",
    flexWrap: "wrap"
  }, /* @__PURE__ */ jsx(Box, {
    flex: "1"
  }, /* @__PURE__ */ jsx(ButtonGroup, {
    attached: true
  }, colorKeys.map((c, i) => /* @__PURE__ */ jsx(ButtonOutline, {
    css: css`
                  color: ${colors[c].fg};
                  background-color: ${colors[c].bg};
                `,
    onClick: onHighlight(c),
    title: t("highlight-title", { id: i + 1 })
  }, colors2[c].label ? `${colors2[c].label} (${i + 1})` : t(`${c}-button`, { id: i + 1 }))))), /* @__PURE__ */ jsx(Box, null, /* @__PURE__ */ jsx(ButtonGroup, {
    attached: true
  }, /* @__PURE__ */ jsx(ButtonOutline, {
    title: t("erase-title"),
    onClick: onErase
  }, t("erase")), /* @__PURE__ */ jsx(ButtonOutline, {
    title: t("reset-title"),
    onClick: onReset
  }, t("reset"))))), /* @__PURE__ */ jsx(Box, {
    borderColor: "primary.800",
    borderWidth: "standard",
    borderRadius: "standard",
    borderStyle: "solid",
    overflowX: "auto",
    ref,
    onPointerUp: handleSelect
  }, /* @__PURE__ */ jsx(Box, {
    as: "pre",
    margin: "standard",
    display: "inline-block"
  }, cells)));
};

// src/reducer.ts
import { produce } from "immer";
var initialState = {
  highlights: []
};
var eraseAction = () => ({
  type: "erase"
});
var highlightAction = (color) => ({
  type: "highlight",
  payload: {
    color
  }
});
var resetAction = () => ({
  type: "reset"
});
var selectAction = (from, to) => ({
  type: "select",
  payload: {
    from,
    to
  }
});
var initTextAction = (text) => ({
  type: "init-text",
  payload: {
    text
  }
});
var answerAction = ({
  answer
}) => ({
  type: "answer",
  payload: {
    answer
  }
});
var reducer = produce((draft, action) => {
  var _a, _b, _c, _d;
  switch (action.type) {
    case "init-text":
      draft.highlights = new Array(action.payload.text.length).fill(null);
      break;
    case "reset":
      return {
        highlights: [...draft.highlights].fill(null)
      };
    case "erase":
      if (((_a = draft.selection) == null ? void 0 : _a.from) !== void 0 && ((_b = draft.selection) == null ? void 0 : _b.to) !== void 0) {
        draft.highlights = draft.highlights.fill(null, draft.selection.from, draft.selection.to);
        draft.selection = {
          from: 0,
          to: 0
        };
      }
      break;
    case "select":
      draft.selection = action.payload;
      break;
    case "highlight":
      if (((_c = draft.selection) == null ? void 0 : _c.from) !== void 0 && ((_d = draft.selection) == null ? void 0 : _d.to) !== void 0) {
        draft.highlights = draft.highlights.fill(action.payload.color || draft.currentColor || null, draft.selection.from, draft.selection.to);
        draft.selection = {
          from: 0,
          to: 0
        };
      }
      break;
    case "answer":
      return action.payload.answer;
  }
});

// src/EvaluationForm.tsx
var HighlightsInput = ({
  text,
  value,
  colors: colors2,
  onChange
}) => {
  const [state, dispatch] = useReducer(reducer, {
    highlights: value
  });
  useEffect2(() => {
    onChange(state.highlights);
  }, [state.highlights]);
  return /* @__PURE__ */ jsx(HighlightText, {
    colors: colors2,
    selection: state.selection,
    onErase: () => dispatch(eraseAction()),
    onSelect: (from, to) => dispatch(selectAction(from, to)),
    onReset: () => dispatch(resetAction()),
    onHighlight: (color) => () => dispatch(highlightAction(color)),
    text,
    highlights: value
  });
};
var EvaluationForm = ({ name }) => {
  const { t } = useTranslations2(locales_default);
  const { getValues } = useFormContext();
  const view = getValues(`${name}.view`);
  return /* @__PURE__ */ jsx(Fragment, null, /* @__PURE__ */ jsx(FormLabel, {
    htmlFor: "highlights"
  }, t("solution")), /* @__PURE__ */ jsx(FormHelperText, null, t("instruction-solution")), /* @__PURE__ */ jsx(Box2, {
    id: "highlights",
    mt: "standard",
    mb: "standard"
  }, /* @__PURE__ */ jsx(HookFormController, {
    name: `${name}.evaluation.highlights`,
    defaultValue: false,
    render: ({ value, onChange }) => /* @__PURE__ */ jsx(HighlightsInput, {
      text: view.text,
      colors: view.colors,
      value,
      onChange
    })
  })), /* @__PURE__ */ jsx(FormLabel, {
    htmlFor: "cutoffs"
  }, t("cutoffs")), /* @__PURE__ */ jsx(FormHelperText, null, t("instruction-cutoffs")), /* @__PURE__ */ jsx(Box2, {
    id: "cutoffs",
    mt: "standard"
  }, Object.entries(view.colors).filter(([_, v]) => v.enabled).map(([k, v]) => /* @__PURE__ */ jsx(HookFormController, {
    key: k,
    name: `${name}.evaluation.cutoffs.${k}`,
    label: v.label || t(k),
    defaultValue: 0,
    render: (props) => /* @__PURE__ */ jsx(StyledInput, __spreadProps(__spreadValues({}, props), {
      type: "number",
      max: 1,
      min: -1,
      step: 0.1
    }))
  }))));
};

// src/FeedbackForm.tsx
import {
  AutoGrid,
  Box as Box3,
  Checkbox,
  HookFormController as HookFormController2
} from "@openpatch/patches";
import { useTranslations as useTranslations3 } from "@vocab/react";
var FeedbackForm = ({ name }) => {
  const { t } = useTranslations3(locales_default);
  return /* @__PURE__ */ jsx(AutoGrid, {
    gap: "standard"
  }, /* @__PURE__ */ jsx(Box3, null, /* @__PURE__ */ jsx(HookFormController2, {
    name: `${name}.feedback.highlightAgreement`,
    defaultValue: true,
    helperText: t("highlight-agreement-description"),
    render: ({ value, onChange, onBlur }) => /* @__PURE__ */ jsx(Checkbox, {
      onBlur,
      onChange,
      checked: value
    }, t("highlight-agreement"))
  })));
};

// src/schemas.ts
import {
  FeedbackMessageSchema,
  TaskAnswerSchema,
  TaskResultSchema,
  TaskSchema as TaskSchemaBase,
  TaskStatisticSchema
} from "@bitflow/core";
import { z } from "zod";
var HighlightColorSchema = z.enum([
  "maroon",
  "orange",
  "blue",
  "lavender",
  "yellow"
]);
var ColorSchema = z.object({
  enabled: z.boolean(),
  label: z.string().optional()
});
var TaskSchema = TaskSchemaBase.merge(z.object({
  subtype: z.literal("highlighting"),
  view: z.object({
    instruction: z.string(),
    text: z.string(),
    colors: z.object({
      maroon: ColorSchema,
      orange: ColorSchema,
      blue: ColorSchema,
      lavender: ColorSchema,
      yellow: ColorSchema
    })
  }),
  evaluation: TaskSchemaBase.shape.evaluation.merge(z.object({
    cutoffs: z.object({
      maroon: z.number(),
      orange: z.number(),
      blue: z.number(),
      lavender: z.number(),
      yellow: z.number()
    }),
    highlights: z.array(z.union([HighlightColorSchema, z.null()]))
  })),
  feedback: z.object({
    highlightAgreement: z.boolean(),
    agreement: z.array(z.object({
      color: HighlightColorSchema,
      threshold: z.number(),
      feedback: FeedbackMessageSchema
    })).optional()
  })
}));
var StatisticSchema = TaskStatisticSchema.merge(z.object({
  subtype: z.literal("highlighting"),
  avgAgreement: z.object({
    maroon: z.number(),
    orange: z.number(),
    blue: z.number(),
    lavender: z.number(),
    yellow: z.number()
  }),
  highlights: z.object({
    maroon: z.array(z.number()),
    orange: z.array(z.number()),
    blue: z.array(z.number()),
    lavender: z.array(z.number()),
    yellow: z.array(z.number())
  })
}));
var AnswerSchema = TaskAnswerSchema.merge(z.object({
  subtype: z.literal("highlighting"),
  highlights: z.array(z.union([HighlightColorSchema, z.null()]))
}));
var ResultSchema = TaskResultSchema.merge(z.object({
  subtype: z.literal("highlighting"),
  agreement: z.object({
    maroon: z.number(),
    orange: z.number(),
    blue: z.number(),
    lavender: z.number(),
    yellow: z.number()
  }),
  highlightsFeedback: z.array(z.union([z.enum(["correct", "wrong"]), z.null()]))
}));

// src/Statistic.tsx
import { ButtonGroup as ButtonGroup2, ButtonOutline as ButtonOutline2, Box as Box4 } from "@openpatch/patches";
import { useTranslations as useTranslations4 } from "@vocab/react";
import { useState } from "react";
import { css as css2 } from "@emotion/react";
var Statistic = ({ statistic, task }) => {
  const { t } = useTranslations4(locales_default);
  const colorKeys = Object.keys(task.view.colors).filter((c) => task.view.colors[c].enabled).sort((a, b) => a > b ? 1 : -1);
  const [currentColor, setCurrentColor] = useState(colorKeys[0]);
  const cells = task.view.text.split("").map((t2, i) => {
    const count = statistic.highlights[currentColor][i];
    const relativeCount = count / statistic.count;
    return /* @__PURE__ */ jsx("span", {
      title: String(count),
      style: {
        backgroundColor: relativeCount !== 0 ? shadeColor(colors[currentColor].bg, -(relativeCount * 100 - 50)) : void 0,
        color: relativeCount !== 0 ? colors[currentColor].fg : "black"
      },
      key: i
    }, t2);
  });
  return /* @__PURE__ */ jsx(Box4, null, /* @__PURE__ */ jsx(Box4, {
    mb: "standard"
  }, /* @__PURE__ */ jsx(ButtonGroup2, {
    attached: true
  }, colorKeys.map((c, i) => /* @__PURE__ */ jsx(ButtonOutline2, {
    key: c,
    onClick: () => setCurrentColor(c),
    css: currentColor === c ? css2`
                      background-color: ${colors[c].bg};
                      color: ${colors[c].fg};
                    ` : null
  }, t(`${c}-button`, { id: i + 1 }))))), /* @__PURE__ */ jsx(Box4, {
    borderColor: "primary.800",
    borderWidth: "standard",
    borderRadius: "standard",
    borderStyle: "solid",
    overflowX: "auto"
  }, /* @__PURE__ */ jsx(Box4, {
    as: "pre",
    margin: "standard",
    display: "inline-block"
  }, cells)));
};

// src/Task.tsx
import { AutoGrid as AutoGrid2, Box as Box5, Markdown } from "@openpatch/patches";
import { useTranslations as useTranslations5 } from "@vocab/react";
import { forwardRef, useEffect as useEffect3, useImperativeHandle, useReducer as useReducer2 } from "react";

// src/Feedback.tsx
import { Alert } from "@openpatch/patches";
var Feedback = ({ message, severity }) => {
  return /* @__PURE__ */ jsx(Alert, {
    severity
  }, message);
};

// src/Task.tsx
import { css as css3, Global } from "@emotion/react";
var Task = forwardRef(({ task, mode, onAction, answer, onChange, result }, ref) => {
  const { t } = useTranslations5(locales_default);
  const [state, dispatch] = useReducer2(reducer, initialState);
  const customDispatch = (action) => {
    if (!(mode === "recording" || mode === "result")) {
      onAction == null ? void 0 : onAction(action);
      dispatch(action);
    }
  };
  useEffect3(() => {
    if (task.view.text) {
      customDispatch(initTextAction(task.view.text));
    }
  }, []);
  useEffect3(() => {
    if (answer)
      dispatch(answerAction({ answer }));
  }, [answer]);
  useEffect3(() => {
    onChange == null ? void 0 : onChange({ subtype: "highlighting", highlights: state.highlights });
  }, [state.highlights]);
  useImperativeHandle(ref, () => ({
    dispatch
  }));
  const handleSelect = (from, to) => {
    customDispatch(selectAction(from, to));
  };
  const handleHighlight = (color) => () => {
    customDispatch(highlightAction(color));
  };
  const handleErase = () => {
    customDispatch(eraseAction());
  };
  const handleReset = () => {
    customDispatch(resetAction());
  };
  let instruction = task.view.instruction;
  Object.entries(task.view.colors).forEach(([k, v]) => {
    instruction = instruction.replace(new RegExp(`{{${k}}}`, "g"), `<mark id="${k}">${v.label || t(k)}</mark>`);
  });
  return /* @__PURE__ */ jsx(Box5, {
    p: "standard"
  }, /* @__PURE__ */ jsx(Global, {
    styles: Object.entries(colors).map(([k, v]) => css3`
              #user-content-${k} {
                background-color: ${v.bg};
                color: ${v.fg};
                padding: 2px;
              }
            `)
  }), /* @__PURE__ */ jsx(AutoGrid2, {
    gap: "standard"
  }, /* @__PURE__ */ jsx(Markdown, {
    allowHtml: true,
    markdown: instruction
  }), /* @__PURE__ */ jsx(HighlightText, {
    text: task.view.text,
    highlights: state.highlights,
    feedback: result == null ? void 0 : result.highlightsFeedback,
    colors: task.view.colors,
    selection: state.selection,
    onHighlight: handleHighlight,
    onErase: handleErase,
    onReset: handleReset,
    onSelect: handleSelect
  }), (result == null ? void 0 : result.feedback) && /* @__PURE__ */ jsx(Feedback, __spreadValues({}, result.feedback))));
});

// src/updateStatistic.ts
var updateAvg = (avg, value, count) => {
  return (avg * count + value) / (count + 1);
};
var updateStatistic = (_0) => __async(void 0, [_0], function* ({
  answer,
  task: { view },
  statistic,
  result
}) {
  if (!statistic) {
    statistic = {
      count: 0,
      avgAgreement: {
        maroon: 0,
        lavender: 0,
        orange: 0,
        blue: 0,
        yellow: 0
      },
      highlights: {
        maroon: new Array(view.text.length).fill(0),
        lavender: new Array(view.text.length).fill(0),
        orange: new Array(view.text.length).fill(0),
        blue: new Array(view.text.length).fill(0),
        yellow: new Array(view.text.length).fill(0)
      },
      subtype: "highlighting"
    };
  }
  answer.highlights.forEach((h, i) => {
    if (statistic && h !== null) {
      statistic.highlights[h][i] += 1;
    }
  });
  return __spreadProps(__spreadValues({}, statistic), {
    count: statistic.count + 1,
    avgAgreement: {
      maroon: updateAvg(statistic.avgAgreement.maroon, (result == null ? void 0 : result.agreement.maroon) || 0, statistic.count),
      lavender: updateAvg(statistic.avgAgreement.lavender, (result == null ? void 0 : result.agreement.lavender) || 0, statistic.count),
      orange: updateAvg(statistic.avgAgreement.orange, (result == null ? void 0 : result.agreement.orange) || 0, statistic.count),
      blue: updateAvg(statistic.avgAgreement.blue, (result == null ? void 0 : result.agreement.blue) || 0, statistic.count),
      yellow: updateAvg(statistic.avgAgreement.yellow, (result == null ? void 0 : result.agreement.yellow) || 0, statistic.count)
    }
  });
});

// src/useInformation.ts
import { useTranslations as useTranslations6 } from "@vocab/react";
var useInformation = () => {
  const { t } = useTranslations6(locales_default);
  return {
    name: t("name"),
    description: t("description"),
    example: {
      subtype: "highlighting",
      description: "",
      name: t("name"),
      view: {
        instruction: t("example.instruction"),
        text: t("example.text"),
        colors: {
          maroon: { enabled: true },
          lavender: { enabled: true, label: "Veggies" },
          blue: { enabled: false },
          yellow: { enabled: false },
          orange: { enabled: false }
        }
      },
      evaluation: {
        enableRetry: true,
        mode: "auto",
        showFeedback: true,
        cutoffs: {
          orange: 0,
          lavender: 0,
          maroon: 0.8,
          yellow: 0,
          blue: 0
        },
        highlights: new Array(t("example.text").length).fill(null).fill("maroon", 0, 3)
      },
      feedback: {
        highlightAgreement: false
      }
    }
  };
};

// src/ViewForm.tsx
import {
  FormLabel as FormLabel2,
  HookFormController as HookFormController3,
  FormHelperText as FormHelperText2,
  TextEditor,
  Box as Box6,
  CodeEditor,
  Checkbox as Checkbox2,
  Input
} from "@openpatch/patches";
import { useTranslations as useTranslations7 } from "@vocab/react";
import { Fragment as Fragment2 } from "react";
var ViewForm = ({ name }) => {
  const { t } = useTranslations7(locales_default);
  return /* @__PURE__ */ jsx(Fragment2, null, /* @__PURE__ */ jsx(HookFormController3, {
    name: `${name}.view.instruction`,
    label: t("instruction"),
    defaultValue: "",
    render: ({ value, onChange }) => /* @__PURE__ */ jsx(Fragment2, null, /* @__PURE__ */ jsx(TextEditor, {
      variant: "outlined",
      value,
      onChange
    }), /* @__PURE__ */ jsx(FormHelperText2, null, t("instruction-shortcodes")))
  }), /* @__PURE__ */ jsx(HookFormController3, {
    name: `${name}.view.text`,
    label: t("text"),
    defaultValue: "",
    render: ({ value, onChange }) => /* @__PURE__ */ jsx(CodeEditor, {
      variant: "outlined",
      value,
      onChange
    })
  }), /* @__PURE__ */ jsx(FormLabel2, {
    htmlFor: ""
  }, t("enabled-highlight-colors")), /* @__PURE__ */ jsx(FormHelperText2, null, t("instruction-enabled-highlight-colors")), Object.keys(colors).map((c) => {
    return /* @__PURE__ */ jsx(Box6, {
      display: "flex",
      alignItems: "center",
      mt: "standard",
      key: c
    }, /* @__PURE__ */ jsx(Box6, {
      marginRight: "small",
      title: t(c),
      display: "inline-block",
      width: "15px",
      height: "15px",
      style: {
        backgroundColor: colors[c].bg
      }
    }), /* @__PURE__ */ jsx(HookFormController3, {
      name: `${name}.view.colors.${c}.enabled`,
      render: ({ onChange, value, onBlur }) => /* @__PURE__ */ jsx(Checkbox2, {
        checked: value,
        onChange,
        onBlur
      })
    }), /* @__PURE__ */ jsx(HookFormController3, {
      name: `${name}.view.colors.${c}.label`,
      defaultValue: t(c),
      render: Input
    }));
  }));
};
export {
  AnswerSchema,
  EvaluationForm,
  FeedbackForm,
  ResultSchema,
  Statistic,
  StatisticSchema,
  Task,
  TaskSchema,
  ViewForm,
  evaluate,
  kappa,
  updateStatistic,
  useInformation
};
//# sourceMappingURL=index.esm.mjs.map
